package asd.td7;

import asd.base.ObjetAClef;

/**
 * Une classe pour l'exercice 9 de la feuille 7.
 */
public class RangTernaire extends PartitionTernaire {

    /**
     * Construit un objet RangTernaire pour le tableau T.
     */
    public RangTernaire(ObjetAClef[] T) {
	super(T);
    }

    /**
     * Retourne l'lment du tableau de rang k, c'est  dire l'lment
     * qui se trouve  l'indice k-1 dans le tableau tri.
     * Prcondition : 1 <= k <= n o n = taille du tableau.
     * Postrelation : la place des lments dans le tableau a t modifie.
     * Complexit   : O(n) o n = taille du tableau.
     */
    public ObjetAClef rang_1(int k) {
	return rang_1(0,T.length - 1,k - 1);
    }

    /**
     * Retourne l'lment du tableau de rang k+1, c'est  dire l'lment
     * qui se trouve  l'indice k dans le tableau tri.
     * Prcondition : i <= k <= j et x est dans T[i..j] o x est
     * l'lment du tableau de rang k+1.
     * Complexit : O(j-i+1)
     */
    private ObjetAClef rang_1(int i, int j, int k) {
        if ( i == j )
            return T[i];
        int[] P = partitionnerEnTrois_1(i,j);
        if ( k < P[0] )
            return rang_1(i,P[0]-1,k);
        if ( k == P[0] )
            return T[P[0]];
        if ( k < P[1] )
            return rang_1(P[0]+1,P[1]-1,k);
        if ( k == P[1] )
            return T[P[1]];
        return rang_1(P[1]+1,j,k);
    }

    /**
     * Retourne l'lment du tableau de rang k, c'est  dire l'lment
     * qui se trouve  l'indice k-1 dans le tableau tri.
     * Prcondition : 1 <= k <= n o n = taille du tableau.
     * Postrelation : la place des lments dans le tableau a t modifie.
     * Complexit   : O(n) o n = taille du tableau.
     */
    public ObjetAClef rang_2(int k) {
	return rang_2(0,T.length - 1,k - 1);
    }

    /**
     * Retourne l'lment du tableau de rang k+1, c'est  dire l'lment
     * qui se trouve  l'indice k dans le tableau tri.
     * Prcondition : i <= k <= j et x est dans T[i..j] o x est
     * l'lment du tableau de rang k+1.
     * Complexit : O(j-i+1)
     */
    private ObjetAClef rang_2(int i, int j, int k) {
        if ( i == j )
            return T[i];
        int[] P = partitionnerEnTrois_2(i,j);
        if ( k < P[0] )
            return rang_2(i,P[0]-1,k);
        if ( k == P[0] )
            return T[P[0]];
        if ( k < P[1] )
            return rang_2(P[0]+1,P[1]-1,k);
        if ( k == P[1] )
            return T[P[1]];
        return rang_2(P[1]+1,j,k);
    }
}
